<?php
$zing_tickets_name = "Tickets";
$zing_tickets_shortname = "zing_tickets";
$install_type = array("Clean" );
$zing_login_type = array("osTickets","WP");

$zing_tickets_options = array (

array(  "name" => "General settings",
            "type" => "heading",
			"desc" => "This section manages the Tickets settings.",
),
array(	"name" => "Type of integration",
			"desc" => "Select the way you want to login. If you want to use your Wordpress users, select 'WP'. <br />If you want to use the osTickets users, select 'osTickets'",
			"id" => $zing_tickets_shortname."_login",
			"std" => "WP",
			"type" => "select",
			"options" => $zing_login_type),
array(	"name" => "Type of access",
			"desc" => "In case of Wordpress integration, select the way you want guests to access the ticketing system. <br />You can restrict this to Subscribers only or leave it open to everyone",
			"id" => $zing_tickets_shortname."_subscribers",
			"std" => "WP",
			"type" => "select",
			"options" => array("Subscribers","Everyone")),
array(	"name" => "Language",
			"desc" => "Language of ticketing system (customer front end only)",
			"id" => $zing_tickets_shortname."_lang",
			"std" => "en",
			"type" => "select2",
			"options" => array("en"=>"English","es"=>"Spanish")),
);

function zing_tickets_check() {
	global $lang_dir;
	$errors=array();
	$warnings=array();
	$files=array();
	$dirs=array();

	foreach ($files as $file) {
		if (!is_writable($file)) $warnings[]='File '.$file.' is not writable, please chmod to 666';
	}

	$dirs[]=ZING_TICKETS_LOC.'cache';
	foreach ($dirs as $file) {
		if (!is_writable($file)) $warnings[]='Directory '.$file.' is not writable, please chmod to 777';
	}

	if (phpversion() < '5')	$warnings[]="You are running PHP version ".phpversion().". We recommend you ugprade to PHP version 5 or higher.";
	if (ini_get("zend.ze1_compatibility_mode")) $warnings[]="You are running PHP in PHP 4 compatibility mode. We recommend to turn this mode off.";

	return array('errors'=> $errors, 'warnings' => $warnings);
}

function zing_tickets_add_admin() {

	global $zing_tickets_name, $zing_tickets_shortname, $zing_tickets_options;

	if ( $_GET['page'] == 'zingiri-tickets-cp' ) {

		if ( 'update' == $_REQUEST['action'] ) {
			zing_tickets_activate();
			foreach ($zing_tickets_options as $value) {
				if( isset( $_REQUEST[ $value['id'] ] ) ) {
					update_option( $value['id'], $_REQUEST[ $value['id'] ]  );
				} else { delete_option( $value['id'] );
				}
			}
			header("Location: options-general.php?page=zingiri-tickets-cp");
			die;
		}

		if ( 'install' == $_REQUEST['action'] ) {
			zing_tickets_activate();
			foreach ($zing_tickets_options as $value) {
				if( isset( $_REQUEST[ $value['id'] ] ) ) {
					update_option( $value['id'], $_REQUEST[ $value['id'] ]  );
				} else { delete_option( $value['id'] );
				}
			}
			header("Location: options-general.php?page=zingiri-tickets-cp&installed=true");
			die;
		}

		if( 'uninstall' == $_REQUEST['action'] ) {
			zing_tickets_uninstall();
			foreach ($zing_tickets_options as $value) {
				delete_option( $value['id'] );
				update_option( $value['id'], $value['std'] );
			}
			header("Location: options-general.php?page=zingiri-tickets-cp&uninstalled=true");
			die;
		}
	}

	add_menu_page($zing_tickets_name, $zing_tickets_name, 'administrator', 'zingiri-tickets-cp','zing_tickets_admin');
	add_submenu_page('zingiri-tickets-cp', $zing_tickets_name.'- Integration', 'Integration', 'administrator', 'zingiri-tickets-cp', 'zing_tickets_admin');
	add_submenu_page('zingiri-tickets-cp', $zing_tickets_name.'- Administration', 'Administration', 'administrator', 'zingiri-tickets-admin', 'zing_ost_admin');
}

function zing_ost_admin() {
	global $zing_tickets_content;
	global $zing_tickets_menu;
	//global $zing_tickets_post;

	//error_reporting(E_ALL & ~E_NOTICE);
	//ini_set('display_errors', '1');

	if (!$_GET['zscp']) {
		$_GET['zscp']='tickets';
	}

	echo '<div style="width:80%;float:left;position:relative">';
	zing_tickets_header();
	echo $zing_tickets_content;
	echo '</div>';

	echo '<div class="updated" style="width:15%;float:right;position:relative">';
	echo $zing_tickets_menu;
	echo '</div>';


}

function zing_tickets_admin() {

	global $zing_tickets_name, $zing_tickets_shortname, $zing_tickets_options, $wpdb;

	if ( $_REQUEST['installed'] ) echo '<div id="message" class="updated fade"><p><strong>'.$zing_tickets_name.' installed.</strong></p></div>';
	if ( $_REQUEST['uninstalled'] ) echo '<div id="message" class="updated fade"><p><strong>'.$zing_tickets_name.' uninstalled.</strong></p></div>';

	?>
<div class="wrap">
<h2><b><?php echo $zing_tickets_name; ?></b></h2>

	<?php
	$zing_tickets_version=get_option("zing_tickets_version");
	if (empty($zing_tickets_version))
	echo 'Please proceed with a clean install or deactivate your plugin';
	elseif ($zing_tickets_version != ZING_TICKETS_VERSION)
	echo 'You downloaded version '.ZING_TICKETS_VERSION.' and need to upgrade your database (currently at version '.$zing_tickets_version.').';
	elseif ($zing_tickets_version == ZING_TICKETS_VERSION)
	echo 'Your version is up to date!';

	$zing_eaw=zing_tickets_check();
	$zing_errors=$zing_eaw['errors'];
	$zing_warnings=$zing_eaw['warnings'];

	if ($zing_errors) {
		echo '<div style="background-color:pink" id="message" class="updated fade"><p>';
		echo '<strong>Errors - it is strongly recommended you resolve these errors before continuing:</strong><br /><br />';
		foreach ($zing_errors as $zing_error) echo $zing_error.'<br />';
		echo '</p></div>';
	}
	if ($zing_warnings) {
		echo '<div style="background-color:peachpuff" id="message" class="updated fade"><p>';
		echo '<strong>Warnings - you might want to have a look at these issues to avoid surprises or unexpected behaviour:</strong><br /><br />';
		foreach ($zing_warnings as $zing_warning) echo $zing_warning.'<br />';
		echo '</p></div>';
	}

	?>
<form method="post">

<table class="optiontable">

<?php foreach ($zing_tickets_options as $value) {

	if ($value['type'] == "text") { ?>

	<tr align="left">
		<th scope="row"><?php echo $value['name']; ?>:</th>
		<td><input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>"
			type="<?php echo $value['type']; ?>"
			value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>"
			size="40"
		/></td>

	</tr>
	<tr>
		<td colspan=2><small><?php echo $value['desc']; ?> </small>
		<hr />
		</td>
	</tr>

	<?php } elseif ($value['type'] == "textarea") { ?>
	<tr align="left">
		<th scope="row"><?php echo $value['name']; ?>:</th>
		<td><textarea name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" cols="50"
			rows="8"
		/>
		<?php if ( get_settings( $value['id'] ) != "") { echo stripslashes (get_settings( $value['id'] )); }
		else { echo $value['std'];
		} ?>
</textarea></td>

	</tr>
	<tr>
		<td colspan=2><small><?php echo $value['desc']; ?> </small>
		<hr />
		</td>
	</tr>

	<?php } elseif ($value['type'] == "select") { ?>

	<tr align="left">
		<th scope="top"><?php echo $value['name']; ?>:</th>
		<td><select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
		<?php foreach ($value['options'] as $option) { ?>
			<option <?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; }?>><?php echo $option; ?></option>
			<?php } ?>
		</select></td>

	</tr>
	<tr>
		<td colspan=2><small><?php echo $value['desc']; ?> </small>
		<hr />
		</td>
	</tr>

	<?php } elseif ($value['type'] == "select2") { ?>

	<tr align="left">
		<th scope="top"><?php echo $value['name']; ?>:</th>
		<td><select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
		<?php foreach ($value['options'] as $option => $label) { ?>
			<option value="<?php echo $option?>"<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; }?>><?php echo $label; ?></option>
			<?php } ?>
		</select></td>

	</tr>
	<tr>
		<td colspan=2><small><?php echo $value['desc']; ?> </small>
		<hr />
		</td>
	</tr>

	<?php } elseif ($value['type'] == "heading") { ?>

	<tr valign="top">
		<td colspan="2" style="text-align: left;">
		<h2 style="color: green;"><?php echo $value['name']; ?></h2>
		</td>
	</tr>
	<tr>
		<td colspan=2><small>
		<p style="color: red; margin: 0 0;"><?php echo $value['desc']; ?></P>
		</small>
		<hr />
		</td>
	</tr>

	<?php } ?>
	<?php
}
?>
</table>

<?php if (!$zing_tickets_version) { ?>
<p class="submit"><input name="install" type="submit" value="Install" /> <input type="hidden"
	name="action" value="install"
/></p>

<?php } elseif ($zing_tickets_version != ZING_TICKETS_VERSION) { ?>
<p class="submit"><input name="install" type="submit" value="Upgrade" /> <input type="hidden"
	name="action" value="install"
/></p>

<?php } else { ?>

<p class="submit"><input name="install" type="submit" value="Update" /> <input type="hidden"
	name="action" value="update"
/></p>

<?php } ?></form>
<hr />
<p>The following Wordpress users are active osTicket users</p>
<?php if ($zing_tickets_version) {
	//$wpdb->show_errors();
	$prefix=$wpdb->prefix."zing_ost_";

	$query="select * from `##users`,`##usermeta` where `##users`.`ID`=`##usermeta`.`user_id` and `##usermeta`.`meta_key`='wp_user_level'";
	$query=str_replace("##",$wpdb->prefix,$query);
	$sql = mysql_query($query) or die(mysql_error());
	while ($row = mysql_fetch_array($sql)) {
		if ($row['meta_value'] >= 8) { //administrator role
			if (!isset($row['first_name'])) $row['first_name']=$row['display_name'];
			$query2="INSERT INTO `".$prefix."staff` (`staff_id`, `group_id`, `dept_id`, `username`, `firstname`, `lastname`, `passwd`, `email`, `phone`, `phone_ext`, `mobile`, `signature`, `isactive`, `isadmin`, `isvisible`, `onvacation`, `daylight_saving`, `append_signature`, `change_passwd`, `timezone_offset`, `max_page_size`, `created`, `lastlogin`, `updated`) VALUES";
			$query2.="('".$row['ID']."', 1, 1, '".$row['user_login']."', '".$row['first_name']."', '".$row['last_name']."', '".md5($row['user_pass'])."', '".$row['user_email']."', '', '', '', '', 1, 1, 1, 0, 0, 0, 0, 0.0, 0, '".date("Y-m-d")."', NULL, '".date("Y-m-d")."')";
			$wpdb->query($query2);
			$query2=sprintf("UPDATE `".$prefix."staff` SET `passwd`='%s', `isadmin`=1, `change_passwd`=0 WHERE `username`='%s'",md5($row['user_pass']),$row['user_login']);
			$wpdb->query($query2);
		} elseif ($row['meta_value'] >= 5) { //editor role
			if (!isset($row['first_name'])) $row['first_name']=$row['display_name'];
			$query2="INSERT INTO `".$prefix."staff` (`staff_id`, `group_id`, `dept_id`, `username`, `firstname`, `lastname`, `passwd`, `email`, `phone`, `phone_ext`, `mobile`, `signature`, `isactive`, `isadmin`, `isvisible`, `onvacation`, `daylight_saving`, `append_signature`, `change_passwd`, `timezone_offset`, `max_page_size`, `created`, `lastlogin`, `updated`) VALUES";
			$query2.="('".$row['ID']."', 1, 1, '".$row['user_login']."', '".$row['first_name']."', '".$row['last_name']."', '".md5($row['user_pass'])."', '".$row['user_email']."', '', '', '', '', 1, 0, 1, 0, 0, 0, 0, 0.0, 0, '".date("Y-m-d")."', NULL, '".date("Y-m-d")."')";
			$wpdb->query($query2);
			$query2=sprintf("UPDATE `".$prefix."staff` SET `passwd`='%s', `isadmin`=0, `change_passwd`=0 WHERE `username`='%s'",md5($row['user_pass']),$row['user_login']);
			$wpdb->query($query2);
		} else {
			$query2=sprintf("DELETE FROM `".$prefix."staff` WHERE `username`='%s'",$row['user_login']);
			$wpdb->query($query2);
		}
		$level[$row['user_login']]=$row['meta_value'];
	}
	$query="select * from `##users`,`##zing_ost_staff` where `##users`.`user_login`=`##zing_ost_staff`.`username`";
	$query=str_replace("##",$wpdb->prefix,$query);
	$sql = mysql_query($query) or die(mysql_error());
	while ($row = mysql_fetch_array($sql)) {
		echo $row['user_login'].' - '.$row['firstname'].' - '.$row['user_email'];
		if ($level[$row['user_login']] >= 8) echo ' - admin';
		elseif ($level[$row['user_login']] >= 5) echo ' - staff';

		if (md5($row['user_pass']) != $row['passwd']) echo '!Password not synchronised';
		echo '<br />';
	}

	?> <br />
<p>Please note that more settings are available through the osTickets <a
	href="admin.php?page=zingiri-tickets-admin&zscp=admin&t=settings"
>admin panel</a>.</p>
<hr />
<form method="post">
<p class="submit"><input name="uninstall" type="submit" value="Uninstall" /> <input type="hidden"
	name="action" value="uninstall"
/></p>
</form>
	<?php } ?>
<hr />
<p>For more info and support, contact us at <a href="http://www.choppedcode.com/tickets/">ChoppedCode</a> or
check out our <a href="http://forums.choppedcode.com/forums">support forums</a>.</p>
	<?php
}
add_action('admin_menu', 'zing_tickets_add_admin'); ?>