<?php
/*  zingiri_tickets.php
 Copyright 2008,2009,2010 EBO
 Support site: http://www.choppedcode.com

 This file is part of Tickets.

 Tickets is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Tickets is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Tickets; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
?>
<?php
/*
 Plugin Name: Tickets
 Plugin URI: http://www.choppedcode.com/Tickets
 Description: This plugin integrates the fabulous osTicket ticketing solution with Wordpress.
 Author: EBO
 Version: 1.0.6
 Author URI: http://www.choppedcode.com/
 */
define("ZING_TICKETS_VERSION","1.0.6");

// Pre-2.6 compatibility for wp-content folder location
if (!defined("WP_CONTENT_URL")) {
	define("WP_CONTENT_URL", get_option("siteurl") . "/wp-content");
}
if (!defined("WP_CONTENT_DIR")) {
	define("WP_CONTENT_DIR", ABSPATH . "wp-content");
}

if (!defined("ZING_TICKETS_PLUGIN")) {
	$zing_tickets_plugin=str_replace(realpath(dirname(__FILE__).'/..'),"",dirname(__FILE__));
	$zing_tickets_plugin=substr($zing_tickets_plugin,1);
	define("ZING_TICKETS_PLUGIN", $zing_tickets_plugin);
}

if (!defined("ZING_TICKETS_SUB")) {
	if (get_option("siteurl") == get_option("home"))
	{
		define("ZING_TICKETS_SUB", "wp-content/plugins/".ZING_TICKETS_PLUGIN."/osticket/upload/");
	}
	else {
		define("ZING_TICKETS_SUB", "wordpress/wp-content/plugins/".ZING_TICKETS_PLUGIN."/osticket/upload/");
	}
}
if (!defined("ZING_TICKETS_DIR")) {
	define("ZING_TICKETS_DIR", WP_CONTENT_DIR . "/plugins/".ZING_TICKETS_PLUGIN."/osticket/upload/");
}

if (!defined("ZING_TICKETS_LOC")) {
	define("ZING_TICKETS_LOC", WP_CONTENT_DIR . "/plugins/".ZING_TICKETS_PLUGIN."/");
}

if (!defined("ZING_TICKETS_URL")) {
	define("ZING_TICKETS_URL", WP_CONTENT_URL . "/plugins/".ZING_TICKETS_PLUGIN."/");
}
if (!defined("ZING_TICKETS_LOGIN")) {
	define("ZING_TICKETS_LOGIN", get_option("zing_tickets_login"));
}

define("ZING_OST_URL",ZING_TICKETS_URL.'osticket/upload');

$zing_footers[]=array('http://www.osticket.com/','osTicket');
$zing_tickets_version=get_option("zing_tickets_version");
if ($zing_tickets_version) {
	add_action("init","zing_tickets_init");
	add_filter('wp_footer','zing_tickets_footer');
	add_action("plugins_loaded", "zing_tickets_sidebar_init");
	add_filter('the_content', 'zing_tickets_content', 10, 3);
	add_action('wp_head','zing_tickets_header');
}

register_activation_hook(__FILE__,'zing_tickets_activate');
register_deactivation_hook(__FILE__,'zing_tickets_deactivate');
require_once(dirname(__FILE__) . '/includes/shared.inc.php');
require_once(dirname(__FILE__) . '/includes/http.class.php');
require_once(dirname(__FILE__) . '/includes/footer.inc.php');
require_once(dirname(__FILE__) . '/includes/integrator.inc.php');
require_once(dirname(__FILE__) . '/zing_tickets_cp.php');

/**
 * Activation: creation of database tables & set up of pages
 * @return unknown_type
 */
function zing_tickets_activate() {
	global $wpdb;
	global $current_user;
	global $zing_tickets_options;

	$zing_tickets_version=get_option("zing_tickets_version");
	if (!$zing_tickets_version)
	{
		add_option("zing_tickets_version",ZING_TICKETS_VERSION);
	}
	else
	{
		update_option("zing_tickets_version",ZING_TICKETS_VERSION);
	}

	//create database tables
	$wpdb->show_errors();
	$prefix=$wpdb->prefix."zing_ost_";

	if ($handle = opendir(dirname(__FILE__).'/db')) {
		while (false !== ($file = readdir($handle))) {
			if (strstr($file,".sql")) {
				$f=explode("-",$file);
					
				$v=str_replace(".sql","",$f[1]);
				if ($zing_tickets_version < $v) {
					$file_content = file(dirname(__FILE__).'/db/'.$file);
					$query = "";
					foreach($file_content as $sql_line) {
						$tsl = trim($sql_line);
						if (($sql_line != "") && (substr($tsl, 0, 2) != "--") && (substr($tsl, 0, 1) != "#")) {
							$sql_line = str_replace("CREATE TABLE `", "CREATE TABLE `".$prefix, $sql_line);
							$sql_line = str_replace("DELETE FROM `", "DELETE FROM `".$prefix, $sql_line);
							$sql_line = str_replace("INSERT INTO `", "INSERT INTO `".$prefix, $sql_line);
							$sql_line = str_replace("ALTER TABLE `", "ALTER TABLE `".$prefix, $sql_line);
							$sql_line = str_replace("UPDATE `", "UPDATE `".$prefix, $sql_line);
							$sql_line = str_replace("TRUNCATE TABLE `", "TRUNCATE TABLE `".$prefix, $sql_line);
							$query .= $sql_line;

							if(preg_match("/;\s*$/", $sql_line)) {
								$wpdb->query($query);
								$query = "";
							}
						}

					}
				}
			}
		}
		closedir($handle);
	}

	//default settings
	if ($zing_tickets_version <= '0.1') {
		$query="update ".$prefix."config set admin_email='".get_option('admin_email')."'";
		$query.=",helpdesk_url='".get_option('home')."'";
		$wpdb->query($query);
	}

	//default email
	if ($zing_tickets_version <= '0.1') {
		$query="update ".$prefix."email set email='".get_option('admin_email')."'";
		//$query.=",helpdesk_url='".get_option('home')."'";
		$wpdb->query($query);
	}
	
	//default user
	$query="INSERT INTO `".$prefix."staff` (`staff_id`, `group_id`, `dept_id`, `username`, `firstname`, `lastname`, `passwd`, `email`, `phone`, `phone_ext`, `mobile`, `signature`, `isactive`, `isadmin`, `isvisible`, `onvacation`, `daylight_saving`, `append_signature`, `change_passwd`, `timezone_offset`, `max_page_size`, `created`, `lastlogin`, `updated`) VALUES";
	$query.="('".$current_user->data->ID."', 1, 1, '".$current_user->data->user_login."', '".$current_user->first_name."', '".$current_user->last_name."', '".md5($current_user->data->user_pass)."', '".$current_user->data->user_email."', '', '', '', '', 1, 1, 1, 0, 0, 0, 0, 0.0, 0, '".date("Y-m-d")."', NULL, '".date("Y-m-d")."')";
	$wpdb->query($query);
	$query=sprintf("UPDATE `".$prefix."staff` SET `passwd`='%s', `change_passwd`=0 WHERE `username`='%s'",md5($current_user->data->user_pass),$current_user->data->user_login);
	$wpdb->query($query);

	//default options
	foreach ($zing_tickets_options as $value) {
		delete_option( $value['id'] );
		if ( !empty($value['id']) && !get_option($value['id']) ) update_option( $value['id'], $value['std'] );
	}

	//create standard pages
	if ($zing_tickets_version <= '0.1') {
		$pages=array();
		$pages[]=array("Tickets","tickets","*",0);

		$ids="";
		foreach ($pages as $i =>$p)
		{
			$my_post = array();
			$my_post['post_title'] = $p['0'];
			$my_post['post_content'] = '';
			$my_post['post_status'] = 'publish';
			$my_post['post_author'] = 1;
			$my_post['post_type'] = 'page';
			$my_post['comment_status'] = 'closed';
			$my_post['menu_order'] = 100+$i;
			$id=wp_insert_post( $my_post );
			if (empty($ids)) { $ids.=$id; } else { $ids.=",".$id; }
			if (!empty($p[1])) add_post_meta($id,'zing_tickets_page',$p[1]);
		}
		if (get_option("zing_tickets_pages"))
		{
			update_option("zing_tickets_pages",$ids);
		}
		else {
			add_option("zing_tickets_pages",$ids);
		}
	}

	//set comment status to closed
	$ids=get_option("zing_tickets_pages");
	$ida=explode(",",$ids);
	foreach ($ida as $id) {
		$my_post = array();
		$my_post['ID']=$id;
		$my_post['comment_status'] = 'closed';
		wp_update_post($my_post);
	}
}

/**
 * Deactivation
 * @return void
 */
function zing_tickets_deactivate() {
}

/**
 * Uninstallation: removal of database tables
 * @return void
 */
function zing_tickets_uninstall() {
	global $wpdb;

	$tables=array();
	$a='api_key,config,department,email,email_banlist,email_template,groups,help_topic,kb_premade,staff,syslog,ticket,ticket_attachment,ticket_lock,ticket_message,ticket_note,ticket_priority,ticket_response,timezone';
	$tables=explode(",",$a);
	$prefix=$wpdb->prefix."zing_ost_";
	foreach ($tables as $table) {
		$query="drop table ".$prefix.$table;
		$wpdb->query($query);
	}
	$ids=get_option("zing_tickets_pages");
	$ida=explode(",",$ids);
	foreach ($ida as $id) {
		wp_delete_post($id);
	}
	delete_option("zing_tickets_version",ZING_VERSION);
	delete_option("zing_tickets_pages",ZING_VERSION);
}

/**
 * Main function handling content, footer and sidebars
 * @param $process
 * @param $content
 * @return unknown_type
 */
function zing_tickets_main($process,$content="") {
	global $zing_tickets_content;

	if ($zing_tickets_content) $content=$zing_tickets_content;
	return $content;
}

function zing_tickets_output($process) {

	global $post;
	global $wpdb;
	global $cfg;
	global $thisuser;
	global $nav;
	global $zing_tickets_loaded,$zing_tickets_mode;

	$content="";

	switch ($process)
	{
		case "content":
			if (isset($_POST['zname'])) {
				$_POST['name']=$_POST['zname'];
				unset($_POST['zname']);
			}
			$cf=get_post_custom($post->ID);
			if (isset($_GET['zpage']))
			{
				$to_include=$_GET['zpage'];
				$zing_tickets_mode="client";
			}
			elseif (isset($_GET['zscp']))
			{
				$to_include="scp/".$_GET['zscp'];
				$zing_tickets_mode="admin";
			}
			elseif (isset($_GET['zsetup']))
			{
				$to_include="setup/".$_GET['zscp'];
				$zing_tickets_mode="setup";
			}
			elseif (isset($cf['zing_tickets_page']))
			{
				$zing_tickets_mode="client";
				$to_include=$cf['zing_tickets_page'][0];
			}
			elseif (isset($cf['zing_tickets_page']) && ($cf['zing_tickets_page'][0]=='admin'))
			{
				$to_include="scp/".$_GET['zscp'];
				$zing_tickets_mode="admin";
			}
			else
			{
				return $content;
			}
			if (isset($cf['cat'])) {
				$_GET['cat']=$cf['cat'][0];
			}
			break;
		default:
			return $content;
			break;
	}

	if (get_option("zing_tickets_subscribers") == "Subscribers" && !is_user_logged_in()) {
		$content="Access not allowed, please register or login first";
		return $content;
	}

	zing_tickets_login();
	$http=zing_tickets_http("osticket",$to_include.'.php');
	$news = new HTTPRequest($http);
	if ($news->live()) {
		$output=$news->DownloadToString(true);
		if ($news->redirect) {
			$redirect='index.php?page_id='.zing_tickets_mainpage().'&zpage=tickets';//.trim(str_replace(array('Location:','.php'),'',$output));
			header('Location:'.$redirect);
			die();
		}
		$content.=zing_tickets_ob($output);
		return $content;
	}
}

function zing_tickets_mainpage() {
	$ids=get_option("zing_tickets_pages");
	$ida=explode(",",$ids);
	return $ida[0];
}

function zing_tickets_ob($buffer) {
	global $current_user,$zing_tickets_mode;
	$home=get_option('home');
	$admin=get_option('siteurl').'/wp-admin';
	$pid=zing_tickets_mainpage();

	//login
	if (strpos($buffer,'loginBody')===false) $loginPage=false;
	else $loginPage=true;

	$buffer=zing_integrator_tags($buffer,"ost");
	$buffer=str_replace('"install.php"','"'.$home.'/index.php?page_id='.$pid.'&zpage=setup/install"',$buffer);
	$buffer=str_replace('action=install.php','action="'.$home.'/index.php?page_id='.$pid.'&zpage=setup/install"',$buffer);
	$buffer=str_replace('"style.css"','"'.ZING_OST_URL.'/setup/style.css"',$buffer);

	//admin
	$buffer=str_replace('../scp/admin.php','"'.$home.'/index.php?page_id='.$pid.'&zscp=admin"',$buffer);
	if ($zing_tickets_mode=="admin") {
		foreach (array('login','scp','main','style','tabs','autosuggest_inquisitor') as $css) {
			$buffer=str_replace('css/'.$css.'.css',ZING_TICKETS_URL.'css/admin/'.$css.'.css',$buffer);
		}
		foreach (array('ajax','tabber') as $js) {
			$buffer=str_replace('js/'.$js.'.js',ZING_OST_URL.'/scp/js/'.$js.'.js',$buffer);
		}
		foreach (array('bsn.AutoSuggest_2.1.3','autolock','calendar','scp') as $js) {
			$buffer=str_replace('js/'.$js.'.js',ZING_TICKETS_URL.'js/'.$js.'.js',$buffer);
		}
		foreach (array('index','admin','tickets','kb','directory','profile','logout') as $page) {
			if (is_admin()) {
				$buffer=str_replace('"'.$page.'.php?','"'.$admin.'/admin.php?page=zingiri-tickets-admin&zscp='.$page.'&',$buffer);
				$buffer=str_replace('"'.$page.'.php"','"'.$admin.'/admin.php?page=zingiri-tickets-admin&zscp='.$page.'"',$buffer);
				$buffer=str_replace("'".$page.'.php?',"'".$admin.'/admin.php?page=zingiri-tickets-admin&zscp='.$page.'&',$buffer);
				$buffer=str_replace("'".$page.'.php"',"'".$admin.'/admin.php?page=zingiri-tickets-admin&zscp='.$page.'"',$buffer);

			} else {
				$buffer=str_replace('"'.$page.'.php?','"'.$home.'/index.php?page_id='.$pid.'&zscp='.$page.'&',$buffer);
				$buffer=str_replace('"'.$page.'.php"','"'.$home.'/index.php?page_id='.$pid.'&zscp='.$page.'"',$buffer);
				$buffer=str_replace("'".$page.'.php?',"'".$home.'/index.php?page_id='.$pid.'&zscp='.$page.'&',$buffer);
				$buffer=str_replace("'".$page.'.php"',"'".$home.'/index.php?page_id='.$pid.'&zscp='.$page.'"',$buffer);
			}
		}
		$buffer=str_replace('attachment.php',ZING_TICKETS_URL.'attachment.php',$buffer);
		$buffer=str_replace('action="login.php"','action="'.$home.'/index.php?page_id='.$pid.'&zscp=login"',$buffer);
		$buffer=preg_replace('/.a id="logo".*a>/','',$buffer);
		$buffer=str_replace("src='images/","src='".ZING_OST_URL."/scp/images/",$buffer);
		$buffer=str_replace('src="images/','src="'.ZING_OST_URL.'/scp/images/',$buffer);
		$buffer=str_replace('method="get">','method="get"><input type="hidden" name="page_id" value="'.$pid.'" /><input type="hidden" name="zscp" value="admin" />',$buffer);
		$buffer=str_replace('method="GET" >','method="GET" ><input type="hidden" name="page_id" value="'.$pid.'" /><input type="hidden" name="zscp" value="admin" />',$buffer);
		$buffer=str_replace('src="autocron.php"','src="'.ZING_OST_URL.'/scp/autocron.php"',$buffer);

		//remove Change password option
		if (get_option('zing_tickets_login') == "WP") zing_integrator_cut($buffer,'<li><a class="userPasswd"','</li>');

		//missing div causes themes to break
		if (!$loginPage) $buffer='<div>'.$buffer;

		//client
	} elseif ($zing_tickets_mode=="client") {
		foreach (array('tickets','open','view','logout') as $page) {
			$buffer=str_replace('"'.$page.'.php?','"'.$home.'/index.php?page_id='.$pid.'&zpage='.$page.'&',$buffer);
			$buffer=str_replace('"'.$page.'.php"','"'.$home.'/index.php?page_id='.$pid.'&zpage='.$page.'"',$buffer);
		}
		foreach (array('main','colors') as $css) {
			$buffer=str_replace('./styles/'.$css.'.css',ZING_TICKETS_URL.'css/client/'.$css.'.css',$buffer);
		}
		$buffer=str_replace('id="header"','id="header" style="display:none"',$buffer);
		$buffer=str_replace('action="login.php"','action="'.$home.'/index.php?page_id='.$pid.'&zpage=login"',$buffer);
		$buffer=str_replace("src='images/","src='".ZING_OST_URL."/images/",$buffer);
		$buffer=str_replace('src="images/','src="'.ZING_OST_URL.'/images/',$buffer);
		$buffer=str_replace('<ul id="nav">','<ul id="ostnav">',$buffer);
		if (get_option("zing_tickets_subscribers") == "Subscribers" && is_user_logged_in()) zing_integrator_cut($buffer,'<a class="log_out"','</a>');
		$buffer=zing_tickets_translate($buffer);
	}

	$buffer=str_replace('<div id="content"','<div',$buffer);

	return '<!--buffer:start-->'.$buffer.'<!--buffer:end-->';
}

function zing_tickets_translate($buffer) {
	$lang=get_option("zing_tickets_lang");
	if ($lang=='' or $lang=='en') return $buffer;
	require(dirname(__FILE__).'/langs/en.inc.php');
	require(dirname(__FILE__).'/langs/'.$lang.'.inc.php');
	$c=get_defined_constants(true);
	foreach ($c['user'] as $n => $v) {
		if (strstr($n,'en_') !==false) {
			$m=str_replace('en_',$lang.'_',$n);
			if (defined($m)) $buffer=str_replace($v,constant($m),$buffer);
		}
	}
	return $buffer;
}

function zing_tickets_http($module,$to_include="index",$page="",$key="") {
	$vars="";
	if (!$to_include || $to_include==".php") $to_include="index";
	$http=ZING_OST_URL.'/';
	$http.= $to_include;
	$and="";
	if (count($_GET) > 0) {
		foreach ($_GET as $n => $v) {
			if ($n!="zpage" && $n!="page_id" && $n!="zscp") {
				$vars.= $and.$n.'='.zing_urlencode($v);
				$and="&";
			}
		}
	}
	if ($vars) $http.='?'.$vars;
	return $http;
}

/**
 * Page content filter
 * @param $content
 * @return unknown_type
 */
function zing_tickets_content($content) {
	return zing_tickets_main("content",$content);
}


/**
 * Header hook: loads FWS addons and css files
 * @return unknown_type
 */
function zing_tickets_header()
{
	global $zing_tickets_content;
	global $zing_tickets_menu;
	global $zing_tickets_post;

	if (isset($_POST) && isset($zing_tickets_post)) {
		$_POST=array_merge($_POST,$zing_tickets_post);
	}

	$output=zing_tickets_output("content");

	echo '<script type="text/javascript" language="javascript">';
	echo "var ajaxurl='".ZING_TICKETS_URL."osticket/upload/scp/';";
	echo "var ajaxurlloc='".ZING_TICKETS_URL."ajax/';";
	echo '</script>';

	zing_integrator_cut($output,'<div id="footer">','</div>');
	$head=zing_integrator_cut($output,'<div id="osthead">','</div>',true);

	$menu1=zing_integrator_cut($output,'<p id="info">','</p>');
	if ($menu1) {
		$menu1=strchr($menu1,'<a');
		$menu1=str_replace('<a','<li><a',$menu1);
		$menu1=str_replace('</a>','</a></li>',$menu1);
		$menu1='<ul>'.$menu1.'</ul>';
		$menu1=str_replace('|','',$menu1).'<br />';
	}
	$menu=zing_integrator_cut($output,'<div id="nav">','</div>');
	zing_integrator_cut($output,'<div id="header"','</div>');

	$menu=str_replace('<ul id="main_nav" >','<ul>',$menu);
	$menu=str_replace('<ul id="sub_nav">','<br /><ul>',$menu);
	$zing_tickets_menu=$menu1.$menu;
	$zing_tickets_content=$output;

	//stylesheets and javascripts
	echo $head;
	echo '<link rel="stylesheet" type="text/css" href="' . ZING_TICKETS_URL . 'zing.css" media="screen" />';
}

/**
 * Sidebar menu widget
 * @param $args
 * @return unknown_type
 */
function widget_zingiri_tickets_menu($args) {
	global $nav, $thisuser;
	global $zing_tickets_menu;

	extract($args);
	echo $before_widget;
	echo $before_title;
	echo "Tickets";
	echo $after_title;
	if ($zing_tickets_menu!='') {
		echo $zing_tickets_menu;
	} else {
		echo '<ul>';
		if (current_user_can('edit_plugins')) echo '<li><a href="?page_id='.zing_tickets_mainpage().'&zscp=admin">Admin Panel</a></li>';
		elseif (current_user_can('edit_pages')) echo '<li><a href="?page_id='.zing_tickets_mainpage().'&zscp=tickets">Staff Panel</a></li>';
		echo '</ul>';
	}
	echo $after_widget;
}

/**
 * Register sidebar widgets
 * @return unknown_type
 */
function zing_tickets_sidebar_init()
{
	if (current_user_can('edit_plugins') || current_user_can('edit_pages')) {
		register_sidebar_widget(__('Tickets Menu'), 'widget_zingiri_tickets_menu');
	}
}

/**
 * Initialization of page, action & page_id arrays
 * @return unknown_type
 */
function zing_tickets_init()
{
	global $zing_tickets_post;
	if (isset($_POST['name']) && (isset($_POST['submit_x']) || isset($_POST['submit']))) {
		$zing_tickets_post['name']=$_POST['name'];
		unset($_POST['name']);
	}

	ob_start();
	session_start();
	if (isset($_GET['zpage']) && !isset($_GET['page_id'])) $_GET['page_id']=zing_tickets_mainpage();
}

function zing_tickets_login() {
	global $current_user,$wpdb;

	if (defined("ZING_TICKETS_LOGIN") && ZING_TICKETS_LOGIN=="WP") {
		if (current_user_can('edit_plugins')  || current_user_can('edit_pages')) {
			$post['do']='scplogin';
			$post['username']=$current_user->data->user_login;
			$post['passwd']=$current_user->data->user_pass;
			$post['submit']='Login';
			$http=zing_tickets_http('osticket','scp/login.php');
		} elseif (is_user_logged_in()) {
			//Guest login extension
			include(dirname(__FILE__).'/extensions/guest_login.php');
		}
		if ($http) {
			$news = new HTTPRequest($http);
			$news->post=$post;
			if ($news->live()) {
				$output=$news->DownloadToString(true);
			}
		}
	}

}
/**
 * Display common footer
 * @param $page_id
 * @return unknown_type
 */
function zing_tickets_footer() {
	zing_footers();
}

?>